﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace APLComCsHelper
{
    //IMPORTANT NOTES:
    // For this class to perform properly, Aplwco.dll and aplw.exe must be registered as COM
    // A reference to APL+Win Type Library (aplwco.dll) must be made in the Solution Explorer
    public class APLComCsHelper
    {
        private APLW.WSEngine w = new APLW.WSEngine();
        //^When an instance of the APLComCsHelper class is created
        //  an instance of the APLW com is also created.
        //
        public void APLClose()
        {
            w.Close();
            try
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(w);
            }
            catch { }
            finally
            {
                w = null;
                System.GC.Collect();
                System.GC.WaitForPendingFinalizers();
            }
            //^  Use the Microsoft-suggested method for disposing of  COM objects accessed from .Net
            //    Refer to http://support.microsoft.com/kb/317109 for details

        }
        public object APLCall(string UDFfnm,object rarg, object larg)
        {
            return w.Call(UDFfnm,rarg,larg);
        }
        public object APLExec(string expr)
        {
            return w.Exec(expr);
        }
        public object APLSysCall(string FNfnm, object rarg, object larg)
        {
            return w.SysCall(FNfnm, rarg, larg);
        }
        public void APLSysCmd(string cmd)
        {
            w.SysCommand(cmd);
        }
        public object APLGetSysVarVal(String SysVarName)
        {
            return w.get_SysVariable(SysVarName);
        }
        public void APLSetSysVarVal(String SysVarName, object val)
        {
             w.set_SysVariable(SysVarName, val);
        }
        public object APLGetUDVarVal(String UDVarName)
        {
            return w.get_Variable(UDVarName);
        }
        public void APLSetUDVarVal(String UDVarName, object val)
        {
            w.set_Variable(UDVarName, val);
        }
        public Int32 APLGetVisible()
        {
            return w.Visible;
        }
        public void APLSetVisible(Int32 v)
        {
            w.Visible = v;
        }
    }
}
